Loading...
Searching...
No Matches
AVHWDeviceContext Struct Reference

This struct aggregates all the (hardware/vendor-specific) "high-level" state, i.e. More...

`#include <libavutil/hwcontext.h>`

## Data Fields

const AVClass * | av_class
| A class for logging.
enum AVHWDeviceType | type
| This field identifies the underlying API used for hardware access.
void * | hwctx
| The format-specific data, allocated and freed by libavutil along with this context.
void(* | free )(struct AVHWDeviceContext *ctx)
| This field may be set by the caller before calling av_hwdevice_ctx_init().
void * | user_opaque
| Arbitrary user data, to be used e.g.

## Detailed Description

This struct aggregates all the (hardware/vendor-specific) "high-level" state, i.e.

state that is not tied to a concrete processing configuration. E.g., in an API that supports hardware-accelerated encoding and decoding, this struct will (if possible) wrap the state that is common to both encoding and decoding and from which specific instances of encoders or decoders can be derived.

This struct is reference-counted with the AVBuffer mechanism. The av_hwdevice_ctx_alloc() constructor yields a reference, whose data field points to the actual AVHWDeviceContext. Further objects derived from AVHWDeviceContext (such as AVHWFramesContext, describing a frame pool with specific properties) will hold an internal reference to it. After all the references are released, the AVHWDeviceContext itself will be freed, optionally invoking a user-specified callback for uninitializing the hardware state.

Definition at line 63 of file hwcontext.h.

## Field Documentation

## av_class

const AVClass* AVHWDeviceContext::av_class

A class for logging.

Set by av_hwdevice_ctx_alloc().

Definition at line 67 of file hwcontext.h.

## type

enum AVHWDeviceType AVHWDeviceContext::type

This field identifies the underlying API used for hardware access.

This field is set when this struct is allocated and never changed afterwards.

Definition at line 75 of file hwcontext.h.

## hwctx

void* AVHWDeviceContext::hwctx

The format-specific data, allocated and freed by libavutil along with this context.

Should be cast by the user to the format-specific context defined in the corresponding header (hwcontext_*.h) and filled as described in the documentation before calling av_hwdevice_ctx_init().

After calling av_hwdevice_ctx_init() this struct should not be modified by the caller.

Definition at line 88 of file hwcontext.h.

## free

void(* AVHWDeviceContext::free) (struct AVHWDeviceContext *ctx)

This field may be set by the caller before calling av_hwdevice_ctx_init().

If non-NULL, this callback will be called when the last reference to this context is unreferenced, immediately before it is freed.

Note
  when other objects (e.g an AVHWFramesContext) are derived from this struct, this callback will be invoked after all such child objects are fully uninitialized and their respective destructors invoked.

Definition at line 100 of file hwcontext.h.

## user_opaque

void* AVHWDeviceContext::user_opaque

Arbitrary user data, to be used e.g.

by the free() callback.

Definition at line 105 of file hwcontext.h.

The documentation for this struct was generated from the following file:

- libavutil/hwcontext.h